//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------


LRESULT CALLBACK IOProc(LPMMIOINFO lpMMIOInfo, UINT uMessage, LPARAM lParam1, LPARAM lParam2);
__fastcall TForm1::TForm1(TComponent* Owner) : TForm(Owner)
{ mmioInstallIOProc(mmioFOURCC('M','R','E','S'),(LPMMIOPROC)IOProc,MMIO_INSTALLPROC | MMIO_GLOBALPROC);
  HRSRC hres=FindResource(HInstance,MAKEINTRESOURCE(1),"AVI");
  HGLOBAL hGlob=LoadResource(HInstance,hres);
  void *data=LockResource(hGlob);        
  int size=SizeofResource(HInstance,hres);       
  AnsiString fn=".MRES+0x"+IntToHex((int)data,8)+"?0x"+IntToHex(size,8);
  MediaPlayer->FileName=fn; eName->Text=fn; MediaPlayer->Open();
}
//---------------------------------------------------------------------------



// This IOProc accepts filenames with element specifications +addr?size, where
// both addr and size must be 10-character numbers in the form 0x00000000
// It would have been easier simply to use the MEM predefined IO type. But that
// would have required that we make the call to mmioOpen ourselves. Our present
// solution integrates a lot more easily with the TMediaPlayer.
// Our IOProc is very limited. It only reads, and does no checking.
LRESULT CALLBACK IOProc(LPMMIOINFO lpMMIOInfo, UINT uMessage, LPARAM lParam1, LPARAM lParam2)
{ switch (uMessage)
  { case MMIOM_OPEN:
    { lpMMIOInfo->lDiskOffset = 0;
      AnsiString fn=AnsiString((char*)lParam1);
      AnsiString saddr=fn.SubString(7,10);
      AnsiString ssize=fn.SubString(18,10);
      lpMMIOInfo->adwInfo[0]=saddr.ToInt();
      lpMMIOInfo->adwInfo[1]=ssize.ToInt();
      return 0;
    }
    case MMIOM_CLOSE: return 0;
    case MMIOM_READ:
    { char *data=(char*)lpMMIOInfo->adwInfo[0];
      memcpy((void *)lParam1,data+lpMMIOInfo->lDiskOffset,lParam2);
      lpMMIOInfo->lDiskOffset += lParam2;
      return (lParam2);
    }
    case MMIOM_SEEK:
    { switch (lParam2)
      { case 0: lpMMIOInfo->lDiskOffset = lParam1; break;
        case 1: lpMMIOInfo->lDiskOffset += lParam1; break;
        case 2: lpMMIOInfo->lDiskOffset = lpMMIOInfo->adwInfo[1] - 1 - lParam1; break;
      }
      return lpMMIOInfo->lDiskOffset;
    }
    default:  return -1; // Unexpected msgs.  For instance, we do not process MMIOM_WRITE in this sample
  }
}

